unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Menus, Gauges, iHtml, Buttons, ComCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    N1: TMenuItem;
    N2: TMenuItem;
    Exit1: TMenuItem;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Panel2: TPanel;
    LblUrlNum: TLabel;
    Panel3: TPanel;
    LblUrlLoto: TLabel;
    Status: TStatusBar;
    MemNumbers: TMemo;
    MemLoto: TMemo;
    BitBtn1: TBitBtn;
    procedure N2Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
  private
    FMemBuf: TMemoryStream;
    FStrBuf: TStrings;
    FDataFileUrl: TStrings;
    FGauge: TGauge;
    procedure ShowStatus(const Msg: string);
    procedure Progress(const MaxValue, CurValue: integer; const Mode: TProgressMode);

    procedure GetFiles(const TopPageUrl: string; MsgBuf: TStrings);
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

uses
    iMisc;

{$R *.dfm}

var
    WORK_DIR: string;

//  ---------------------------------------------------------------------------
//  񃁃bZ[W_CAO
procedure SimpleMessage(AMsg: string);
var
    Dialog: TForm;
    Image : TImage;
begin
    Application.NormalizeTopMosts;

    Dialog := CreateMessageDialog(AMsg, mtInformation, [mbOK]);
    try
        Image := TImage(Dialog.FindComponent('Image'));
        if (Image <> nil) then Image.Picture.Icon.Assign(Application.Icon);
        Dialog.ShowModal;
    finally
        Dialog.Free;
    end;

    Application.RestoreTopMosts;
end;

//  ---------------------------------------------------------------------------
//  mFbZ[W_CAO
function SimpleYesNo(AMsg: string): Boolean;
var
    Dialog: TForm;
    Image : TImage;
begin
    Application.NormalizeTopMosts;

    Dialog := CreateMessageDialog(AMsg, mtInformation, [mbYes, mbNo]);
    try
        Image := TImage(Dialog.FindComponent('Image'));
        if (Image <> nil) then Image.Picture.Icon.Assign(Application.Icon);
        Result := (Dialog.ShowModal = mrYes);
    finally
        Dialog.Free;
    end;

    Application.RestoreTopMosts;
end;

//  ---------------------------------------------------------------------------
//  URL̎t@Co
function ExtractUrlFileName(const URL: string): string;
var
    index: integer;
begin
    index := LastDelimiter('/', URL);
    Result := Copy(URL, index + 1, Length(URL));
end;

//  ---------------------------------------------------------------------------
//  URL̎fBNgo
function ExtractUrlFilePath(const URL: string): string;
var
    index: integer;
begin
    index := LastDelimiter('/', URL);
    Result := Copy(URL, 1, index);
end;

//  ---------------------------------------------------------------------------
//  bZ[W\
procedure ShowMsg(const Msg: string; Target: TStrings);
begin
    Target.Add(FormatDateTime('yyyy/mm/dd hh:mm:ss', Now()) + ' >' + Msg);
end;

//  ---------------------------------------------------------------------------
//  Xe[^Xo[ɕ\
procedure TForm1.ShowStatus(const Msg: string);
begin
    Status.Panels[1].Text := Msg;
end;

//  ---------------------------------------------------------------------------
//  tH[
procedure TForm1.FormCreate(Sender: TObject);
begin
    FGauge := TGauge.Create(Self);
    FGauge.Parent := Status;
    FGauge.Left := 2;
    FGauge.Top := 2;
    FGauge.Width := Status.Panels[0].Width - 3;
    FGauge.Height := Status.Height - 3;
    FGauge.BackColor := Status.Color;
    FGauge.ForeColor := clBlack;
    FGauge.Show();

    FMemBuf := TMemoryStream.Create;
    FStrBuf := TStringList.Create;
    FDataFileUrl := TStringList.Create;
end;

//  ---------------------------------------------------------------------------
//  tH[j
procedure TForm1.FormDestroy(Sender: TObject);
begin
//    FGauge.Free;
    FMemBuf.Free;
    FStrBuf.Free;
    FDataFileUrl.Free;
end;

//  ---------------------------------------------------------------------------
//  ۑtH_J
procedure TForm1.N2Click(Sender: TObject);
begin
    SimpleShellExecute(WORK_DIR);
end;

//  ---------------------------------------------------------------------------
//  I
procedure TForm1.Exit1Click(Sender: TObject);
begin
    Self.Close();
end;

//  ---------------------------------------------------------------------------
//  i\
procedure TForm1.Progress(const MaxValue, CurValue: integer; const Mode: TProgressMode);
var
    Buf: string;
begin
    case Mode of

    pmFirst:
        if (MaxValue = 0) then
            Buf := Format('TCYs', [])
        else
            Buf := Format('%doCg/%doCg', [CurValue, MaxValue])
        ;

    pmProgress:
        if (MaxValue = 0) then
            Buf := Format('%doCg/TCYs', [CurValue])
        else
            Buf := Format('%doCg/%doCg', [CurValue, MaxValue])
        ;

    pmFinish:
        Buf := '';
    end;

    FGauge.MaxValue := MaxValue;
    FGauge.Progress := CurValue;
    ShowStatus(Buf);
end;

//  ---------------------------------------------------------------------------
procedure TForm1.GetFiles(const TopPageUrl: string; MsgBuf: TStrings);

    procedure ShowMsgNum(const Msg: string);
    begin
        ShowMsg(Msg, MsgBuf);
    end;

var
    i, index1, index2: integer;
    Url, Buf, Line: string;
begin
    //  Ny[W擾
    Url := TopPageUrl;
    FMemBuf.Clear;
    ShowMsgNum(Format('擾Jn: %s', [Url]));
    GetHtmlFile(FMemBuf, Url, Progress);
    ShowMsgNum(Format('擾: %d oCg', [FMemBuf.Size]));

    //  Ny[Wۑ
    Buf := WORK_DIR + ExtractUrlFileName(Url);
    FMemBuf.SaveToFile(Buf);
    ShowMsgNum(Format('ۑ: %s', [Buf]));

    //  f[^y[WURL𒊏o
    FDataFileUrl.Clear;
    ShowMsgNum(Format('URLoJn: %s', [Buf]));
    FStrBuf.LoadFromStream(FMemBuf);
    FGauge.MaxValue := FStrBuf.Count;
    for i := 0 to FStrBuf.Count - 1 do
    begin
        FGauge.Progress := i;
        Line := Trim(FStrBuf[i]);
        index1 := Pos('href="', Line);
        if (index1 > 0) then
        begin
            Delete(Line, 1, index1 + Length('href="') - 1);
            index2 := Pos('"', Line);
            if (index2 > 0) then
            begin
                Line := Copy(Line, 1, index2 - 1);
                Buf := ExtractUrlFilePath(Url) + Line;
                FDataFileUrl.Add(Buf);
                ShowMsgNum(Format(': %s', [Buf]));
            end;
        end;
    end;
    FGauge.MaxValue := 0;
    ShowMsgNum(Format('URLo', []));

    //  f[^y[W擾
    ShowMsgNum(Format('f[^y[W擾Jn: S%dt@C', [FDataFileUrl.Count]));
    for i := 0 to FDataFileUrl.Count - 1 do
    begin
        //  f[^y[W擾
        Url := FDataFileUrl[i];
        FMemBuf.Clear;
        ShowMsgNum(Format('(%2d/%2d)擾Jn: %s', [i+1, FDataFileUrl.Count, Url]));
        GetHtmlFile(FMemBuf, Url, Progress);
        ShowMsgNum(Format('       擾: %d oCg', [FMemBuf.Size]));

        //  f[^y[Wۑ
        Buf := WORK_DIR + ExtractUrlFileName(Url);
        FMemBuf.SaveToFile(Buf);
        ShowMsgNum(Format('       ۑ: %s', [Buf]));
    end;
    ShowMsgNum(Format('f[^y[W擾', []));
end;
//  ---------------------------------------------------------------------------
procedure TForm1.BitBtn1Click(Sender: TObject);
begin
    if PageControl1.ActivePageIndex = 0 then
        GetFiles(LblUrlNum.Caption, MemNumbers.Lines)
    else
        GetFiles(LblUrlLoto.Caption, MemLoto.Lines)
    ;
end;

initialization
    WORK_DIR := IncludeTrailingPathDelimiter(ExtractFilePath(ParamStr(0))) + 'dat\';
    ForceDirectories(WORK_DIR);
finalization

end.

